<template>
  <v-row>
    <Alert :alert="alert"/>
    <v-col cols="12">
        <v-card class="rounded-lg">
            <v-card-text>
                <v-row>
                    <v-col cols="12" md="7" xl="9">
                        <v-text-field
                            v-model="title"  
                            label="Title"
                            outlined
                            hide-details>

                        </v-text-field>
                    </v-col>
                    <v-col cols="12" md="3" xl="2">
                        <v-select
                            v-model="status"  
                            label="Status" 
                            :items="items"
                            item-text="text"
                            item-value="value"
                            outlined
                            clearable
                            hide-details>

                        </v-select>
                    </v-col>
                    <v-col cols="12" md="2" xl="1">
                        <v-btn 
                            class="btn-primary mt-2" 
                            :loading="loading"
                            @click="getTodoList">
                            Search
                        </v-btn>
                    </v-col>
                </v-row>
            </v-card-text>
        </v-card>
    </v-col>
    <v-col cols="12">
        <v-card 
            class="rounded-lg"
            min-height="500px">
            <v-card-text class="text-right">
                <v-btn class="btn-primary" small @click="showModel">Add new todo</v-btn>
            </v-card-text>
            <hr class="mx-5" />
            <v-card-text class="d-flex flex-wrap justify-center">
                <TodoItem 
                    v-for="item in todoList" 
                    :key="item.id" 
                    :todoItem="item" 
                    @showAlert="showAlert"
                    @reloadList="getTodoList"/> 
                <h1 class="w-100 text-center mt-5" v-if="todoList.length === 0">No record found</h1>
            </v-card-text>
            <v-overlay 
                :absolute="true"
                :value="overlay"
                opacity="0.8">
                <v-progress-circular
                    indeterminate
                    size="50"
                ></v-progress-circular>
            </v-overlay>
        </v-card>
    </v-col>
    <v-dialog 
        v-model="dialog" 
        width="800px"
        persistent>
        <AddTodo 
            @closeDialog="closeModel" 
            @reloadList="getTodoList"
            @showAlert="showAlert"
            v-if="dialog"/>
    </v-dialog>
  </v-row>
</template>

<script>
import Alert from '../components/Alert.vue';

export default {
    data() {
        return {
            title: "",
            status: "",
            loading: false,
            overlay: false,
            items: [{ text: "Active", value: "true" }, { text: "Inactive", value: "false" }],
            dialog: false,
            todoList: [],
            alert : {
                show: false,
                type : "success",
                text : ""
            }
        };
    },
    watch :{
        'alert.show' : function(newVal){
            if (newVal){
                setTimeout(()=>{
                    this.alert.show = false;
                }, 2000);
            }
        }
    },
    methods: {
        showModel() {
            this.dialog = true;
        },
        closeModel() {
            this.dialog = false;
        },
        getTodoList() {
            this.todoList = [];
            this.loading = true;
            this.overlay = true;
            let req = {
                title: this.title,
                isActive: this.status || ""
            };
            this.$axios.post("/todo/search", req)
                .then(resp => {
                if (resp && resp.data.length > 0) {
                    this.todoList = resp.data;
                }
                this.loading = false;
                this.overlay = false;
            })
                .catch(error => {
                console.error("API error : ", error);
                this.loading = false;
                this.overlay = false;
            });
        },
        showAlert(data){
            if (data){
                this.alert.type = data.type;
                this.alert.text = data.text;
                this.alert.show = true;
            }
        }
    },
    created() {
        this.getTodoList();
    },
    components: { Alert }
}
</script>

<style>

</style>